<!-- richTxt 富文本 -->
<template>
  <div class="">
    <div id="editorElem" class="editorElem" :style="{width:width}"></div>
  </div>
</template>

<script>
import E from 'wangeditor'
export default {
  name: 'richTxt',
  props: {
    width: {
      default: '700px'
    },
    content: {
      default: ''
    }

  },

  data() {
    return {
      editorContent: '',
      editor: '',

      msg: null,
      xhrArr: [],
      type: 3,
    }
  },
  mounted() {
    this.init()
  },
  methods: {
    //初始化方法
    init() {
      this.setUpload()
      this.editor.create()
      this.editor.txt.html(this.content)

    },

    getContent() {
      return this.editor.txt.html()
    },

    //配置图片上传
    setUpload() {
      this.editor = new E('#editorElem')
      //  console.log(document.getElementById('editorElem'))
      //this.editor.customConfig.debug = true
      // this.editor.customConfig.uploadImgShowBase64 = true   // 使用 base64 保存图片
      // this.editor.customConfig.uploadImgHeaders = this.m_headers
      // this.editor.customConfig.uploadImgServer = this.m_action  // 上传图片到服务器
      // this.editor.customConfig.uploadFileName = 'images'
      // this.editor.customConfig.uploadImgMaxLength = 1 //最大上传数量
      // this.editor.customConfig.uploadImgTimeout = 10000 //超时时间
      // this.editor.customConfig.withCredentials = true   //上传cookie
      this.editor.customConfig.menus = [
        'head',  // 标题
        'bold',  // 粗体
        'fontSize',  // 字号
        'fontName',  // 字体
        'italic',  // 斜体
        'underline',  // 下划线
        'strikeThrough',  // 删除线
        'foreColor',  // 文字颜色
        'backColor',  // 背景颜色
        'link',  // 插入链接
        'list',  // 列表
        'justify',  // 对齐方式
        'quote',  // 引用
        //'emoticon',  // 表情
        'image',  // 插入图片
        'table',  // 表格
        'video',  // 插入视频
        'code',  // 插入代码
        'undo',  // 撤销
        'redo'  // 重复

      ]
      this.customUploadImg()


    },

    //自定义图片上传
    customUploadImg() {
      this.editor.customConfig.customUploadImg = (files, insert) => {
        //   console.log(files)
        let len = files.length
        // for (let i = 0; i < len; i++) {
        this.submit(files[0], insert)
        // }
      }
    },







    submit(rst, insert) {
      let that = this
      this.showMsg()


      // console.log(res)

      let formData = new FormData()



      formData.append('images', rst)

      var xhr = new XMLHttpRequest()
      that.xhrArr.push(xhr)

      xhr.open('POST', this.m_action, true)
      xhr.timeout = 10000   //超时
      xhr.onload = function () {
        if (xhr.status === 200 || xhr.status === 304) {
          that.hideMsg()
          let res = JSON.parse(this.response);
          let url = res.data;
          insert(url)

        }
      }

      //错误上传
      xhr.onerror = function (res) {
        that.hideMsg()
        console.log(res, 'error')
        that.$emit('error', res)

      }

      //超时
      xhr.ontimeout = function (res) {
        that.hideMsg()
        that.$emit('error', res)
      }

      xhr.send(formData)



    },


 


    showMsg() {
      if (this.msg) {
        // console.log('已经用msg')
        return

      }
      //  console.log('开启msg')
      this.msg = this.$message({
        showClose: true,
        message: '图片上传中 <i class="el-icon-loading"></i>',
        type: 'warning',
        duration: 0,
        dangerouslyUseHTMLString: true,
      });
    },

    hideMsg() {
      this.xhrArr.shift()
      // console.log( this.xhrArr.length,'22222')
      if (this.xhrArr.length == 0) {
        this.msg && this.msg.close()
        this.msg = ""

      }

    },




    //插入图片
    appendImg(url) {
      let img = `<img src="${url}">`
      this.editor.txt.append(img)
    },
  },


}

</script>
<style lang='scss' >
.editorElem {
  height: 500px;
}
</style>